package cs155.hw3;


import java.awt.Color;

/**
 * class represents a 3D plane
 */

public class Plane3D extends Object3D
{
    public Point3D center,normal;

    public Plane3D (Point3D center, Point3D normal, Material m) {
        super();
	this.center=center;
        this.normal=normal.normalize();
        this.insideMat = this.outsideMat = m;
    }


     public Plane3D (Point3D center, Point3D normal)
     {
	 this(center,normal,Material.defaultMat);
     }

      
     public RayHit rayIntersect(Ray3D r) {
      Point3D P = r.p, D=r.d;
      Point3D PC = P.subtract(center);
      double 
	  dn = normal.dot(D),
          cpn = normal.dot(PC),
          t;
      if (dn==0.0) return RayHit.NO_HIT;
      double t0 = -cpn/dn;
      if (t0 < epsilon)
	  return RayHit.NO_HIT;
      else
	  return new RayHit(t0,normal,this);
     }

     
}

  

