;; evaluating this expression generates a list of objects, cameras, and lights that are added to the scene
;; by the JScheme program running the GUI. Note this has to be a single expression, that's why we have the outer "begin" expression

(begin
 (define m1 (Material. (Color3D. 0d 0d 0d) (Color3D. 0d 0d 0d) (Color3D. 0d 0.1d 0.8d) (Color3D. 0.1d 0.15d 0d) 150 0.1d 0.0d))
 (define m2 (Material. (Color3D. 0.0d 0.0d 0.0d) (Color3D. 0.0d 0.0d 0.0d) (Color3D. 0.5d 0.1d 0.1d) (Color3D. 0.1d 0.2d 1d) 150 0.2d 0.0d))
 (define m3 (Material. (Color3D. 0d 0d 0.1d) (Color3D. 0.1d 0d 0d) (Color3D. 0d 0.8d 0.1d) (Color3D. 0.1d 0.15d 0d) 150 0.2d 0.0d))
 (define cam (Camera3D. (Point3D. 0d 0d 0d)))
 (define (rotY A C) (.rotateY C (Math.toRadians A)))
 (define (rotX A C) (.rotateX C (Math.toRadians A)))
 (define (rotZ A C) (.rotateZ C (Math.toRadians A)))
 (define (tr x y z C) (.translate C (Point3D. x y z)))
 (define (sc x y z C) (.scale C x y z))
 (define s0 (Sphere3D. (Point3D. 0d 0d 0d) 100d m1))
 (define s1 (Sphere3D. (Point3D. 0d 0d 0d) 100d m3))
 (define s2 (TransformedObject3D. s1))
 (list
;    (tr 0d 50d 200d (rotX 0d (tr 0d 0d 100d (rotY 90d cam))))
    (tr 0d 0d 500d (rotY 90d cam))
    (Light3D. (Point3D. 0d 0d 500d) 1d)
    (Light3D. (Point3D. 0d 400d 100d) 1d)
    (Light3D. (Point3D. 0d 4d -100d) 1d)
    (Light3D. (Point3D. 50d 10d 0d) 1d)
    (Sphere3D. (Point3D. 60d 4d -110d) 9d)
    (Plane3D. (Point3D. 0d -100d 0d) (Point3D. 0d 1d 0d) m2)
    (rotY 60d (rotX -45d (tr 0d 150d 0d (sc 2d 0.5d 0.15d s2))))
    (sc 0.75d 3d 0.15d s2)
    (Cylinder3D. (Point3D. 0d 0d 0d) (Point3D. 0d 1d 0d) 10d 50d m1 )
    s0
    (Cylinder3D. (Point3D. 0d 0d 0d) (Point3D. 0d 1d 0d) 10d 500d m1)

  )
)

